#include "stdafx.h"
#include "ScrollViewScriptletPlugin.h"
#include "ScriptletConstant.h"
#include "XMLUtil.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_SCROLLVIEW_NODE, CScrollViewScriptletPlugin);
CScrollViewScriptletPlugin::CScrollViewScriptletPlugin( void )
{

}

CScrollViewScriptletPlugin::~CScrollViewScriptletPlugin( void )
{

}

BOOL CScrollViewScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode )
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CNScrollView* pScrollView = reinterpret_cast<CNScrollView*>(pTarget);
		if (pScrollView == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		CScrollBarUI_Img::PSCROLLBARUI_INFO pInfo_Vert = NULL;
		CScrollBarUI_Img::PSCROLLBARUI_INFO pInfo_Horz = NULL;

		// vscrollbar
		CStringA strVsbElement = pNode->Value();
		strVsbElement.Append(".");
		strVsbElement.Append(CT2CA(SCRIPTLET_VSCROLLBAR_NODE));
		TiXmlElement* pVsbNode = pNode->FirstChildElement(strVsbElement);
		CScrollBarUI_Img::SCROLLBARUI_INFO info_v; // [:2008-12-17] Memory Leak   ۿ 
		if (pVsbNode)
		{
			//CScrollBarUI_Img::SCROLLBARUI_INFO info;
			ZeroMemory(&info_v, sizeof(info_v));
			info_v.bHorz = FALSE;
			this->_CreateComponent_ScrollBar(pVsbNode, &info_v);
			pInfo_Vert = &info_v;
		}

		// hscrollbar
		CStringA strHsbElement = pNode->Value();
		strHsbElement.Append(".");
		strHsbElement.Append(CT2CA(SCRIPTLET_HSCROLLBAR_NODE));
		TiXmlElement* pHsbNode = pNode->FirstChildElement(strHsbElement);
		CScrollBarUI_Img::SCROLLBARUI_INFO info_h; // [:2008-12-17] Memory Leak   ۿ 
		if (pHsbNode)
		{
			//CScrollBarUI_Img::SCROLLBARUI_INFO info;
			ZeroMemory(&info_h, sizeof(info_h));
			info_h.bHorz = TRUE;
			this->_CreateComponent_ScrollBar(pHsbNode, &info_h);
			pInfo_Horz = &info_h;
		}
		pScrollView->AddScrollBar(pInfo_Horz, pInfo_Vert);

		// wheelhop
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_WHEELHOP_NODE), lValue) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_WHEELHOP_NODE), lValue))
		{
			ATLASSERT(lValue >= 0); //hhdatlassert
			if ( !(lValue >= 0) ) return NULL;

			pScrollView->SetWheelHop(lValue);
		}
		// linehop
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_LINEHOP_NODE), lValue) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_LINEHOP_NODE), lValue))
		{
			ATLASSERT(lValue >= 0); //hhdatlassert
			if ( !(lValue >= 0) ) return NULL;

			pScrollView->SetLineHop(lValue);
		}
		pScrollView->UpdateScrollInfo();
	}
	return bSuccess;
}

CComponent* CScrollViewScriptletPlugin::_CreateComponent( TiXmlElement* pNode )
{	
	CComponent* pComponent = new CNScrollView();	
	return pComponent;
}

void CScrollViewScriptletPlugin::_CreateComponent_ScrollBar( TiXmlElement* pSbNode, CScrollBarUI_Img::PSCROLLBARUI_INFO pInfo)
{
	ATLASSERT(pSbNode != NULL);
	TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
	long lValue = 0;

	// btn_lefttop
	CStringA strLtElement = pSbNode->Value();
	this->_GetLastNodeName(&strLtElement);
	strLtElement.Append(".");
	strLtElement.Append(CT2CA(SCRIPTLET_BTN_LEFTTOP_NODE));
	TiXmlElement* pLtNode = pSbNode->FirstChildElement(strLtElement);
	if (pLtNode)
	{
		TiXmlElement* pImgNode = pLtNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgBtn_LeftTop = pImage;
				}
			}
		}
	}

	// rightbottom
	CStringA strRbElement = pSbNode->Value();
	this->_GetLastNodeName(&strRbElement);
	strRbElement.Append(".");
	strRbElement.Append(CT2CA(SCRIPTLET_BTN_RIGHTBOTTOM_NODE));
	TiXmlElement* pRbNode = pSbNode->FirstChildElement(strRbElement);
	if (pRbNode)
	{
		TiXmlElement* pImgNode = pRbNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgBtn_RightBottom = pImage;
				}
			}
		}
	}

	// bg_normal
	CStringA strBgNormalElement = pSbNode->Value();
	this->_GetLastNodeName(&strBgNormalElement);
	strBgNormalElement.Append(".");
	strBgNormalElement.Append(CT2CA(SCRIPTLET_BG_NORMAL_NODE));
	TiXmlElement* pBgNormalNode = pSbNode->FirstChildElement(strBgNormalElement);
	if (pBgNormalNode)
	{
		TiXmlElement* pImgNode = pBgNormalNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgBgNormal = pImage;
				}
			}
		}
	}

	// bg_sel
	CStringA strBgSelElement = pSbNode->Value();
	this->_GetLastNodeName(&strBgSelElement);
	strBgSelElement.Append(".");
	strBgSelElement.Append(CT2CA(SCRIPTLET_BG_SEL_NODE));
	TiXmlElement* pBgSelNode = pSbNode->FirstChildElement(strBgSelElement);
	if (pBgSelNode)
	{
		TiXmlElement* pImgNode = pBgSelNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgBgSelected = pImage;
				}
			}
		}
	}

	// thumb_1
	CStringA strThumb1Element = pSbNode->Value();
	this->_GetLastNodeName(&strThumb1Element);
	strThumb1Element.Append(".");
	strThumb1Element.Append(CT2CA(SCRIPTLET_THUMB_1_NODE));
	TiXmlElement* pThumb1Node = pSbNode->FirstChildElement(strThumb1Element);
	if (pThumb1Node)
	{
		TiXmlElement* pImgNode = pThumb1Node->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgThumb_1 = pImage;
				}
			}
		}
	}

	// thumb_2
	CStringA strThumb2Element = pSbNode->Value();
	this->_GetLastNodeName(&strThumb2Element);
	strThumb2Element.Append(".");
	strThumb2Element.Append(CT2CA(SCRIPTLET_THUMB_2_NODE));
	TiXmlElement* pThumb2Node = pSbNode->FirstChildElement(strThumb2Element);
	if (pThumb2Node)
	{
		TiXmlElement* pImgNode = pThumb2Node->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgThumb_2 = pImage;
				}
			}
		}
	}

	// thumb_3
	CStringA strThumb3Element = pSbNode->Value();
	this->_GetLastNodeName(&strThumb3Element);
	strThumb3Element.Append(".");
	strThumb3Element.Append(CT2CA(SCRIPTLET_THUMB_3_NODE));
	TiXmlElement* pThumb3Node = pSbNode->FirstChildElement(strThumb3Element);
	if (pThumb3Node)
	{
		TiXmlElement* pImgNode = pThumb3Node->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgThumb_3 = pImage;
				}
			}
		}
	}

	// thumb_4
	CStringA strThumb4Element = pSbNode->Value();
	this->_GetLastNodeName(&strThumb4Element);
	strThumb4Element.Append(".");
	strThumb4Element.Append(CT2CA(SCRIPTLET_THUMB_4_NODE));
	TiXmlElement* pThumb4Node = pSbNode->FirstChildElement(strThumb4Element);
	if (pThumb4Node)
	{
		TiXmlElement* pImgNode = pThumb4Node->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgThumb_4 = pImage;
				}
			}
		}
	}

	// thumb_5
	CStringA strThumb5Element = pSbNode->Value();
	this->_GetLastNodeName(&strThumb5Element);
	strThumb5Element.Append(".");
	strThumb5Element.Append(CT2CA(SCRIPTLET_THUMB_5_NODE));
	TiXmlElement* pThumb5Node = pSbNode->FirstChildElement(strThumb5Element);
	if (pThumb5Node)
	{
		TiXmlElement* pImgNode = pThumb5Node->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
		if (pImgNode)
		{
			// src
			if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
				XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
			{
				IImage* pImage = LoadImage(szValue);
				if (pImage)
				{
					pInfo->pImgThumb_5 = pImage;
				}
			}
		}
	}
}

void CScrollViewScriptletPlugin::_GetLastNodeName( CStringA* pStrNodeName )
{
	CStringA strLastNodeName;

	int iStart = 0;
	strLastNodeName = pStrNodeName->Tokenize(".", iStart);
	strLastNodeName = pStrNodeName->Tokenize(".", iStart);
	pStrNodeName->SetString(strLastNodeName);
}